Bug 163878 - [exp-run] add -pthread to all perl language builds
Summary: [exp-run] add -pthread to all perl language builds
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: Steve Wills
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-01-06 21:50 UTC by Steve Wills
Modified: 2012-02-15 02:10 UTC (History)
0 users

See Also:


Attachments
file.diff (5.53 KB, patch)
2012-01-06 21:50 UTC, Steve Wills
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Steve Wills freebsd_committer 2012-01-06 21:50:07 UTC
Some perl modules dlopen things linked against libthr, which causes them to hang. This patch will add -pthread to the build of perl, which should prevent this problem. Requesting exp-run due to them being such important ports.

Fix: see attached patch

Patch attached with submission follows:
Comment 1 Mark Linimon freebsd_committer freebsd_triage 2012-01-06 23:14:19 UTC
Responsible Changed
From-To: freebsd-ports-bugs->portmgr

portmgr territory.
Comment 2 Steve Wills freebsd_committer 2012-02-08 02:16:55 UTC
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Any update on this? It's been a while.

Steve
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.18 (FreeBSD)

iQEcBAEBAgAGBQJPMdsXAAoJEPXPYrMgexuhIr8IAIBkvtOL1Z1+LOhRFX2C7wqQ
/jO+pvonxi+v89UWTUi9I94pjAREAHv0dLcf52u7KQZI3WhDAdvrnqsMkakiXi4m
F2EWD9QLJJvNMwrMIsNs1JIOxulbvkPm6PTvbGIPhMg0i1wc5vXllrZIrcxUDep+
w1Ke+lPUZosdAm31ASfIlNjWPKZsMLmC7sQ89TKS+cx8h3mn/xL5Qt01Can2iXij
pBdzXkZTjPOGVTYc+XK3WV3JDj2gWsXNBI2h/huEztCPrHO8TwL1t7h667gCokDa
5PnZIzw7ZE9Kc+SZ/HNPoVxnMUel9Uqj2ffIWyUY4z5HRGtoAORfGwhRlZOBJDw=
=A408
-----END PGP SIGNATURE-----
Comment 3 Pav Lucistnik freebsd_committer 2012-02-08 10:01:17 UTC
On 2012/02/08 03:20, Steve Wills wrote:

>   Any update on this? It's been a while.

This is unlikely to be ever approved, as this would break a large number 
of unthreaded embedded perl applications.

-- 
Pav Lucistnik <pav@oook.cz>
               <pav@FreeBSD.org>
Comment 4 Steve Wills freebsd_committer 2012-02-08 13:44:08 UTC
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

On 02/08/12 05:01, Pav Lucistnik wrote:
> On 2012/02/08 03:20, Steve Wills wrote:
> 
>> Any update on this? It's been a while.
> 
> This is unlikely to be ever approved, as this would break a large
> number of unthreaded embedded perl applications.
> 

This shouldn't break anything. This is NOT enabling the useithreads
option in perl. This is simply building with the -pthread command line
argument to cc so that if perl or a perl module dlopens a lib which
uses threads, then the threads can work properly. Please see PR 163512.

Steve
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.18 (FreeBSD)

iQEcBAEBAgAGBQJPMnwoAAoJEPXPYrMgexuh+gAH/0vVWvrbe+DgUs+AvQBu70le
kGqcz+x/C6ntutOyjxa7N5fYMbu7LUGpcDjQqe55o412PD0hxZMAyOovn5v/FNHM
AAmYeaBDKHw+ZCAcqo021zoeiQo/U1Pk/f+qfURgVvWx9sPgarDdUn3cVVXk+FCd
8HfFJwnoo7GCfoOSLI4fsHAJFDEx2X67euZqFgpm3Hl01zV5Rlpwsumsud57GDYf
mmlaX3HDikDAI6+xO4H7NjPdqkD5eYLqvxW4x86INkeKMi3f+aTmpHlG51yDS1x+
FTYqb3Hm2gyHlzkBKdqmkW++3wUFqAFoOiyUUTdnRi2Ggs5+xnzkFrrxDhmdN0c=
=pCEx
-----END PGP SIGNATURE-----
Comment 5 Anton Berezin freebsd_committer 2012-02-09 17:20:49 UTC
> On 2012/02/08 03:20, Steve Wills wrote:
>
> >   Any update on this? It's been a while.
>
> This is unlikely to be ever approved, as this would break a large number
> of unthreaded embedded perl applications.

<rant>
Is there any reason for even contemplating that portmgr approval (as opposed
to maintainer's, skv@, approval) is required for this PR?

My understanding is that the only reason for this PR to be currently held
portmgr's hostage is because the exp-run was requested.
</rant>

Let me remind involved parties that for a couple of month back in
2000-single digit year we did have -pthread on by default in lang/perl*.
The *only* casualty was amavisd because of our main thread stack size being
ridiculously small.

Steve has already found out that this is not an issue for any perl >= 5.10,
see http://www.mail-archive.com/amavis-user@lists.sourceforge.net/msg14896.html

In the meantime, we are forced to compile fully threaded perl in order to
use such highly useful ports like p5-ZeroMQ, or even prevent xchat with perl
support from coredumping.  Threaded perl is substantially larger evil than
this change, which is for all intents and purposes is totally harmless.

Steve was being prudent by asking for an exp-run, and he did not get it for
a month now.  Personally, I would just let skv@ commit it, or commit it
after 2-week timeout.  :-)

Seriously, people.
\Anton.
-- 
Our society can survive even a large amount of irrational regulation.
  -- John McCarthy
Comment 6 Erwin Lansing freebsd_committer 2012-02-09 19:41:42 UTC
State Changed
From-To: open->analyzed

Take for -exp run
Comment 7 Erwin Lansing freebsd_committer 2012-02-14 16:57:39 UTC
Responsible Changed
From-To: portmgr->swills

Return to submitter for commit. 
i386-9-exp completed successfully with no perl related errors.
Comment 8 Steve Wills freebsd_committer 2012-02-14 18:45:43 UTC
Responsible Changed
From-To: swills->skv

- Over to skv@ for his approval since he is maintainer of these ports
Comment 9 Steve Wills freebsd_committer 2012-02-15 01:57:31 UTC
Responsible Changed
From-To: skv->swills

Taking back for commit, per portmgr approval.
Comment 10 dfilter service freebsd_committer 2012-02-15 02:03:38 UTC
swills      2012-02-15 02:03:30 UTC

  FreeBSD ports repository

  Modified files:
    lang/perl5.10        Makefile 
    lang/perl5.12        Makefile 
    lang/perl5.14        Makefile 
    lang/perl5.8         Makefile 
  Log:
  - Add option to build with -pthread, default to on. Note this is not the same
    as threaded perl.
  
  PR:             ports/163878
  Submitted by:   swills (myself)
  Approved by:    portmgr (erwin)
  Discussed with: tobez
  With hat:       perl@
  
  Revision  Changes    Path
  1.131     +4 -2      ports/lang/perl5.10/Makefile
  1.139     +4 -2      ports/lang/perl5.12/Makefile
  1.140     +4 -1      ports/lang/perl5.14/Makefile
  1.119     +4 -2      ports/lang/perl5.8/Makefile
_______________________________________________
cvs-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/cvs-all
To unsubscribe, send any mail to "cvs-all-unsubscribe@freebsd.org"
Comment 11 Steve Wills freebsd_committer 2012-02-15 02:07:55 UTC
State Changed
From-To: analyzed->closed

Committed.